Subject: Re: [PATCH 7/9] git-hash-object: Add --stdin-paths option

From: Eric Wong <[email-masked]>
Date: Tue, 23 Oct 2007 23:11:23 -0700

"Shawn O. Pearce" <[email-masked]> wrote:
> Adam Roben <[email-masked]> wrote:
> > Shawn O. Pearce wrote:
> > >Adam Roben <[email-masked]> wrote:
> > >  
> > >>This allows multiple paths to be specified on stdin.
> > >
> > >git-fast-import wasn't suited to the task?
> > 
> > I actually considered using fast-import for the whole shebang, but 
> > decided that I don't yet understand the workings and structure of 
> > git-svn well enough to make such a big change.
> > 
> > git-svn uses git-hash-object to both determine a file's hash and insert 
> > it into the index in one go -- can fast-import do this? Or will it just 
> > put it in the index and not give you the hash back? The latter was my 
> > impression.
> 
> It doesn't currently give you the hash back.  You can sort of get
> to it by marking the blob then using the 'checkpoint' command to
> dump the marks to a file, which you can read in.  Not good.
> 
> It probably wouldn't be very difficult to give fast-import a way
> to dump marks back on stdout as they are assigned.  So long as the
> frontend either locksteps with fast-import or is willing to monitor
> it with a select/poll type of arrangement and read from stdout as
> soon as its ready.
> 
> Probably a 5 line code change to fast-import.  Like this.  Only Git
> won't recognize that object SHA-1 as its in a packfile that has
> no index.  You'd need to 'checkpoint' to flush the object out, or
> just use all of fast-import for the processing.  So yea, I guess
> I can see now how its not suited to this.

Shawn, thanks for clearing that up.  I was previously considering
fast-import for git-svn, but never had time[1] to really look at it.

I guess Adam is on the right track with his patches.

[1] - Sorry to all on the list, but I've really been slacking on git-svn
      work.  I was going to get some stuff done this weekend but decided
      to attempt to fight my nasty caffeine addiction instead :x

-- 
Eric Wong